<template>
    <div class="min-h-full">
        <div class="py-10">
            <header>
                <div class="mx-auto max-w-7xl px-4 sm:px-6 lg:px-8">
                    <h1 class="text-3xl font-bold leading-tight tracking-tight text-gray-900">Welcome</h1>
                    <h2 class="text-2xl underline text-gray-900">Book your meeting</h2>
                </div>
            </header>
            <main>
                <div class="mx-auto max-w-7xl sm:px-6 lg:px-8">
                    <form class="space-y-8">
                        <div class="space-y-8 ">
                            <div class="pt-8">
                                <div class="mt-6 grid grid-cols-1 gap-y-6 gap-x-4 sm:grid-cols-6">
                                    <div class="sm:col-span-2">
                                        <label for="email" class="block text-sm font-medium text-gray-700">Email address</label>
                                        <div class="mt-1">
                                            <input required v-model="email" id="email" name="email" type="email" autocomplete="email" class="h-8 block w-full rounded-md border-gray-300 shadow-sm focus:border-indigo-500 focus:ring-indigo-500 sm:text-sm" />
                                        </div>
                                    </div>

                                    <div class="sm:col-span-2">
                                        <label for="participants" class="block text-sm font-medium text-gray-700">Participants</label>
                                        <div class="mt-1">
                                            <select required v-on:change="getRoomForNumberOfParticipant()" v-model="selectedNumberOfParticipants" id="participants" name="participants" class="h-8 text-center cursor-pointer bg-white block w-full rounded-md border-gray-300 shadow-sm focus:border-indigo-500 focus:ring-indigo-500 sm:text-sm">
                                                <option disabled selected value="0">Select number of participants</option>
                                                <option v-for="n in 24" :value="n">{{ n }}</option>
                                            </select>
                                        </div>
                                    </div>
                                    <div class="sm:col-span-2">
                                        <label for="room" class="block text-sm font-medium text-gray-700">Room</label>
                                        <div class="mt-1">
                                            <select required v-model="selectedRoomId" id="room" name="room" class="h-8 text-center cursor-pointer bg-white block w-full rounded-md border-gray-300 shadow-sm focus:border-indigo-500 focus:ring-indigo-500 sm:text-sm">
                                                <option disabled selected value="0">Selected your room</option>
                                                <option v-for="room in availableRooms" :value="room.id">{{ room.name }}</option>
                                            </select>
                                        </div>
                                    </div>
                                    <div class="sm:col-span-2">
                                        <label for="city" class="block text-sm font-medium text-gray-700">Choose date</label>
                                        <div class="mt-1">
                                            <select required v-on:change="changeTimeSlots" class="h-8 text-center cursor-pointer bg-white block w-full rounded-md border-gray-300 shadow-sm focus:border-indigo-500 focus:ring-indigo-500 sm:text-sm" id="date" name="date" v-model="picked" >
                                                <option disabled selected value="">Select your date</option>
                                                <option value="01/01/2025">01/01/2025</option>
                                                <option value="02/01/2025">02/01/2025</option>
                                                <option value="03/01/2025">03/01/2025</option>
                                                <option value="04/01/2025">04/01/2025</option>
                                                <option value="05/01/2025">05/01/2025</option>
                                                <option value="06/01/2025">06/01/2025</option>
                                                <option value="07/01/2025">07/01/2025</option>
                                            </select>
                                        </div>
                                    </div>
                                    <br>
                                    <div v-if="availableSlots.length !== 0" class="sm:col-span-4 grid grid-cols-3 gap-4">
                                        <div v-for="(slot) in availableSlots">
                                            <div :key="slot.id" class="grid place-items-center rounded-xl h-8 cursor-pointer" :class="selectedSlot.id === slot.id ? 'bg-blue-200' : 'bg-gray-200'" v-on:click="toggleSlot(slot)" >{{ slot.slot }}</div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="pt-5">
                            <div class="flex justify-end">
                                <button v-on:click="createBooking" type="button" class="ml-3 inline-flex justify-center rounded-md border border-transparent bg-indigo-600 py-2 px-4 text-sm font-medium text-white shadow-sm hover:bg-indigo-700 focus:outline-none focus:ring-2 focus:ring-indigo-500 focus:ring-offset-2">Book meeting</button>
                            </div>
                        </div>
                    </form>
                </div>
            </main>
        </div>
    </div>
</template>

<script setup>
import { ref } from 'vue';
import dayjs from 'dayjs';
import customParseFormat from 'dayjs/plugin/customParseFormat';
import rooms from '/../../data/rooms.json';
import bookings from '/../../data/bookings.json';
import gql from 'graphql-tag';

dayjs.extend(customParseFormat);

const picked = ref("");
const selectedNumberOfParticipants = ref(0);
const selectedSlot = ref({});
const email = ref("");
const selectedRoomId = ref(0);
const currentBookings = ref([]);
const currentRooms = rooms;
const endTimeBooking = ref("");
let availableRooms = ref([]);
let currentBookingSlots = [];
let availableSlots = ref([]);

const emptyArrays = () => {
    currentBookingSlots = [];
}

const checkIfLengthIsGreaterThanZero = (array) => {
    if (array.length > 0){
        return true
    }
}

const pushToArray = (array, toPushed) => {
    return array.push(toPushed);
}

const getRoomForNumberOfParticipant = () =>{
    if (checkIfLengthIsGreaterThanZero(availableRooms)){
        availableRooms.value = [];
    }

    if (selectedNumberOfParticipants.value === 0 ){
        return;
    }
     currentRooms.forEach(x => {
        if (x.capacity >= selectedNumberOfParticipants.value){
            pushToArray(availableRooms.value,x)
        }
    })
    return availableRooms;
}

const checkAvailableTimeSlots = () => {
    let pickedDate = picked.value;

    if (checkIfLengthIsGreaterThanZero(currentBookingSlots)){
        currentBookingSlots = [];
    }

    for (let i = 0; i < currentBookings.value.length; i++){
        if (currentBookings.value[i].date === pickedDate){
            let startDateAndRoomObject = {};
            startDateAndRoomObject.start_date = currentBookings.value[i].start_time;
            startDateAndRoomObject.room_Id = currentBookings.value[i].room_id;
            pushToArray(currentBookingSlots, startDateAndRoomObject);
        }
    }
};

const convertArrayToArrayOfObjects =  (array) => {
    let arrayOfObject = [];

    for (let i = 0; i < array.length; i++) {
        let obj = {};
        obj.id = i;
        obj.slot = array[i];
        pushToArray(arrayOfObject, obj)
    }
    return arrayOfObject;
}

const filteredSlots = (timeslots) => {
    let currentSlots = [];
    let filteredTimeSlots = [];
    currentBookingSlots.forEach(x => pushToArray(currentSlots, x.start_date));
    filteredTimeSlots = timeslots.filter( slot => !currentSlots.includes(slot));
    filteredTimeSlots = convertArrayToArrayOfObjects(filteredTimeSlots);
    filteredTimeSlots.forEach(x => pushToArray(availableSlots.value, x));
}

const generateTimeSlots = () => {
    if (availableSlots.value.length > 0){
        availableSlots.value = [];
    }
    let x = {slotInterval: 30,openTime:'08:00',closeTime: '17:00'};
    let startTime = dayjs(x.openTime, "HH:mm");
    let endTime = dayjs(x.closeTime, "HH:mm");
    let times = [];

    while(startTime < endTime){
        times.push(startTime.format("HH:mm"))
        startTime = startTime.add(30, 'minutes')
    }
    filteredSlots(times);
}

const toggleSlot = (slot) =>{
    selectedSlot.value = slot;
}

const changeTimeSlots = async () => {
    await getBookingByDate();
    checkAvailableTimeSlots();
    generateTimeSlots();
    emptyArrays();
}

const calcEndTime = () => {
    let startTime = picked.value +' '+ selectedSlot.value.slot + ':00';
    let endtime = dayjs(startTime, "DD/MM/YYYY HH:mm:ss");
    endtime = endtime.add(30, 'minutes');
    endtime = endtime.format("HH:mm");
    endTimeBooking.value = endtime;
}

const getBookingByDate = async () => {

    await fetch('https://full-stack-meeting-room.test/graphql', {
        method: 'POST',
        headers: {
            'Content-Type': 'application/json',
        },
        body: JSON.stringify({
            query: `
                query {
                    bookingsByDate(date: "${picked.value}")
                    {
                        email
                        participants
                        room_id
                        start_time
                        end_time
                        date
                    }
                }
            `,
        }),
    })
        .then(resp => resp.json())
        .then(result => {
            return currentBookings.value = result.data.bookingsByDate
        })
}

const createBooking = () => {
    calcEndTime()
    let selectedNumber = parseInt(selectedNumberOfParticipants.value);
    let roomId = parseInt(selectedRoomId.value);
    let start = selectedSlot.value.slot;

    fetch('https://full-stack-meeting-room.test/graphql',{
        method: 'POST',
        headers:{
            'Content-Type': 'application/json',
        },
        body: JSON.stringify({
            query: `
                mutation {
                    createBooking(email: "${email.value}", participants: ${selectedNumber}, room_id: ${roomId}, start_time: "${start}", end_time: "${endTimeBooking.value}", date: "${picked.value}")
                    {
                        id
                        email
                        participants
                        room_id
                        start_time
                        end_time
                        date
                    }
                }
            `,
        }),
    })
        .then(res => res.json())
        .then(result => {alert('Booking was created')})
}

</script>
